Index: trunk/src/lib/lang/object_list.h
===================================================================
--- trunk/src/lib/lang/object_list.h	(revision 9869)
+++ trunk/src/lib/lang/object_list.h	(revision 9869)
@@ -0,0 +1,383 @@
+/*!
+ * @file object_list.h
+ * @brief Definition of a dynamically allocating ClassID
+ *
+ */
+
+#ifndef _OBJECT_LIST_H
+#define _OBJECT_LIST_H
+
+#include "class_id.h"
+#include <map>
+#include <list>
+#include <string>
+
+#include <cassert>
+#include <iostream>
+
+/**
+ * @brief Use this macro to easily declare a Class to store its own ObjectListDeclaration
+ * @param ClassName the Name of the Class.
+ * @note: Using this inside of a Class means, that you loose the member: _objectList, while defining
+ * two new functions objectList() and classID().
+ */
+#define ObjectListDeclaration(ClassName) \
+  public: \
+   static inline const ObjectList<ClassName>& objectList() { return ClassName::_objectList; }; \
+   static inline const ClassID& staticClassID() { return ClassName::_objectList.identity(); }; \
+  private: \
+   static ObjectList<ClassName> _objectList
+
+/**
+ * @brief Use this macro to easily define a Class to store its own ObjectListDefinition
+ * @param ClassName: the Name of the Class.
+ * @param ID: optional set a Fixed ID.
+ */
+#define ObjectListDefinitionID(ClassName, ID) \
+   ObjectList<ClassName> ClassName::_objectList(#ClassName, ID)
+
+/**
+ * @brief Use this macro to easily define a Class to store its own ObjectListDefinition
+ * @param ClassName: the Name of the Class.
+ */
+#define ObjectListDefinition(ClassName) \
+    ObjectListDefinitionID(ClassName, -1)
+
+class BaseObject;
+//! The superclass that all ObjectLists follow.
+/**
+ * @see template<class T> ObjectList<T>
+ */
+class ObjectListBase
+{
+public:
+  /** @brief A Typedefinition for the Base-List that can be retrieved with getBaseObjectList(base_list*) */
+  typedef std::list<BaseObject*>        base_list;
+  /** @brief An iterator for the base_list */
+  typedef base_list::iterator           base_iterator;
+  //! A fast iterator Base-Class, for iterator-casting and storing.
+  /** @note This Iterator is explicitely used only for storage purposes in the BaseObject */
+  class IteratorBase { };
+
+public:
+  /** @returns The Identity of the Class stored within. */
+  inline const ClassID&                 identity() const { return _identity; }
+  /** @returns the ID of the Identity of the ObjectList */
+  inline int                            id() const { return _id; };
+  /** @returns The Name of the Class stored in this ObjectList */
+  inline const std::string&             name() const { return _name; };
+  /** @param id The id to compare @returns true on match, false otherwise */
+  inline bool                           operator==(int id) const { return _id == id; };
+  /** @param id The id to compare @returns true on match, false otherwise */
+  inline bool                           operator==(const ClassID& id) const { return id == _id; };
+  /** @param name The name to compare @returns true on match, false otherwise */
+  inline bool                           operator==(const std::string& name) const { return _name == name; };
+  /** @param id The id to acquire @param name the Name to acquire @brief stores a Name and an ID in a pointer. */
+  inline void                           acquireID(const int*& id, const std::string*& name) const { id = &_id; name = &_name; };
+  /** @brief fills a list of Objects into a BaseObject*-List. @param list the list to fill */
+  virtual void                          getBaseObjectList(base_list* list) const = 0;
+
+  static const ClassID&                 retrieveIdentity(int id);
+  static const ClassID&                 retrieveIdentity(const std::string& name);
+
+  static const ObjectListBase* const    getObjectList(int classID);
+  static const ObjectListBase* const    getObjectList(const std::string& className);
+  static const ObjectListBase* const    getObjectList(const ClassID& classID);
+
+  static BaseObject*                    getBaseObject(int classID, const std::string& objectName);
+  static BaseObject*                    getBaseObject(const std::string& className, const std::string& objectName);
+  static BaseObject*                    getBaseObject(const ClassID& classID, const std::string& objectName);
+
+  /** @returns an Object with Name name out of this List @param name the name of the Object. */
+  virtual BaseObject*                   getBaseObject(const std::string& name) const = 0;
+
+  static const std::list<std::string>&  getClassNames();
+
+
+  static unsigned int                   classCount();
+  void                                  debug(unsigned int level) const;
+  static void                           debugAll(unsigned int level);
+
+  static const std::string&             IDToString(int classID);
+  static int                            StringToID(const std::string& className);
+
+  //! Only used to unsubscribe a BaseObject. (just try to make a valid iterator, stupid :))
+  virtual void                          unregisterObject(IteratorBase* _iterators) = 0;
+  //! Only for debug purposes
+  virtual bool                          checkIteratorInList(IteratorBase* _iterator) const = 0;
+  virtual bool                          checkObjectInList(BaseObject* obj) const = 0;
+
+protected:
+  ObjectListBase(const std::string& className, int id = -1);
+  virtual ~ObjectListBase();
+
+private:
+  /** @brief hidden copy constructor. */
+  ObjectListBase(const ObjectListBase&) {};
+
+  static bool                         classIDExists(int id);
+  static bool                         classNameExists(const std::string& className);
+
+
+protected:
+  typedef std::map<int, ObjectListBase*>         IDMap;   //!< The Generic Map.
+  typedef std::map<std::string, ObjectListBase*> NameMap; //!< The Generic Map.
+
+private:
+  int                           _id;                //!< The Unique ID of the Class.
+  const std::string             _name;              //!< The Name of the Class.
+  ClassID                       _identity;          //!< The Identity of the Class. (equal to _id and _name)
+
+private:
+  static IDMap*                 _classesByID;       //!< A Map of all the classes in existance.
+  static NameMap*               _classesByName;     //!< A Map of all the classes in existance.
+  static std::list<std::string> _classNames;        //!< A list of all the registered ClassNames.
+};
+
+
+/////////////////////////
+//// TEMPLATISATION /////
+/////////////////////////
+//! Defines a ObjectList handler for objects of type T.
+/**
+ * The ObjectList is a generic way to store every object created from a Class 'T'
+ *  in a List. The list can be retrieved, and used constantly over iterators,
+ *  as with normal std::list.
+ *
+ * Furthermore the linkage over the single Lists is given over the Superclass ObjectListBase.
+ *
+ * The approach of ObjectList is an intrusive one, meaning, that each Class that wants to
+ * support it must implement a Declaration and a Definition for the ObjectList, as mentioned
+ * in the next statement:
+ *
+ * To define a Class with a ObjectList, you have to:
+ *  1. Include 'ObjectListDeclaration(T);' in its Declaration (at the beginning)
+ *  2. Include 'ObjectListDefinition(T);' in some Definition file (cc-file)
+ *  3. In the constructor add 'registerObject(this, objectList);'
+ *
+ * @note The Class must define the compare with const std::string& operator for this to work.
+ *  The operator==(const std::string& name) should compare the object's name with name.
+ *
+ *
+ *
+ * Limitations:
+ *  ObjectList cannot be used with other Factory style Classes, if the class is also a BaseObject,
+ *   and not loaded before the ObjectList.
+ *
+ * example: Iterating: Iteration is made easy, and fast as follows:
+ *   for (ObjectList<PlayerStats>::const_iterator it = PlayerStats::objectList().begin();
+ *      it != PlayerStats::objectList().end();
+ *     ++it)
+ *   {
+ *    (*it)->dosomething
+ *   }
+ *
+ * example: Find an Object:
+ * Playable* playable = Playable::objectList("orxonox-super-rocket-fighter"); // searches an Object By its name.
+ *
+ */
+template<class T>
+class ObjectList : public ObjectListBase
+{
+public:
+  typedef std::list<T*>                  list;             //!< The list of Type T* (used for Objects in this ObjectList)
+  typedef typename list::iterator        iterator;         //!< The iterator for the List of type T (use with ObjectList<Type>::iterator)
+  typedef typename list::const_iterator  const_iterator;   //!< A constant iterator for the List of type T (use with ObjectList<Type>::const_iterator)
+
+
+  //! An iterator to store Objects in the BaseObject, and remove Objects fast.
+class Iterator : public ObjectListBase::IteratorBase
+  {
+  public:
+    /** @brief creates an Iterator fast. @param it the Iterator. */
+    inline Iterator(iterator it) { _it = it; }
+    /** @returns the Iterator */
+    inline iterator& it() { return _it; }
+  private:
+    typename ObjectList::iterator _it;  //!< Stored Iterator
+  };
+
+public:
+  ObjectList(const std::string& name, int id = -1);
+  ~ObjectList();
+
+  virtual BaseObject*                getBaseObject(const std::string& name) const;
+  T*                                 getObject(const std::string& name) const;
+  /** @returns A constant list of Objects of this Class. */
+  inline const list&                 objects() const { return _objects; };
+  bool                               exists(const T* const object) const;
+
+  /** @returns an Iterator to the beginning of the List. */
+  inline iterator                    begin() { return _objects.begin(); };
+  /** @returns a constant Iterator to the beginning of the List. */
+  inline const_iterator              begin() const { return _objects.begin(); };
+  /** @returns an Iterator to the end of the List. */
+  inline iterator                    end() { return _objects.end(); };
+  /** @returns a constant Iterator to the beginning of the List. */
+  inline const_iterator              end() const { return _objects.end(); };
+
+  /** @returns true if the List is empty. */
+  inline bool                        empty() const { return _objects.empty(); };
+  /** @returns the size of the List */
+  inline int                         size() const { return _objects.size(); };
+  /** @returns the frontmost Element of the list (normaly the last added Object). */
+  inline T*                          front() const { return _objects.front(); };
+  /** @returns the last added Object */
+  inline T*                          back() const { return _objects.back(); };
+
+
+  ObjectListBase::IteratorBase*      registerObject(T* object);
+  virtual void                       unregisterObject(IteratorBase* iterator);
+  bool                               checkIteratorInList(IteratorBase* iterator) const;
+  bool                               checkObjectInList(BaseObject* obj) const;
+protected:
+  virtual void                       getBaseObjectList(ObjectListBase::base_list* list) const;
+
+
+private:
+  //! the copy constructor will be hidden.
+  ObjectList(const ObjectList& definer) {};
+
+private:
+  list                _objects;     //!< The List of stored Objects of Type T.
+};
+
+
+
+
+
+/////////////////////////
+//// IMPLEMENTATION /////
+/////////////////////////
+/**
+ * @brief creates a new ObjectList
+ * @param name The name of the Class.
+ * @param id The ID of the class if desired, or -1 if an id should be assigned automatically.
+ */
+template <class T>
+ObjectList<T>::ObjectList(const std::string& name, int id)
+    : ObjectListBase(name, id)
+{}
+
+/**
+ * @brief deletes the ObjectList.
+ */
+template <class T>
+ObjectList<T>::~ObjectList()
+{
+  if (!_objects.empty())
+  {
+    // std::cout << "There are " << this->size() << " objects from class " << this->name() << "(id:" << this->id() << ") in existance\n";
+  }
+}
+
+/**
+ * @brief Retrieves a BaseObject matching the Name name in this List.
+ * @param name the Name of the Object.
+ * @returns a BaseObject pointing to the object if found, NULL otherwise.
+ */
+template <class T>
+BaseObject* ObjectList<T>::getBaseObject(const std::string& name) const
+{
+  return this->getObject(name);
+}
+
+
+
+/**
+ * @brief Retrieves an Object of type T matching the Name name in this List.
+ * @param name the Name of the Object.
+ * @returns an Object of type T pointing to the object if found, NULL otherwise.
+ */
+template <class T>
+T* ObjectList<T>::getObject(const std::string& name) const
+{
+  const_iterator it;
+  for (it = this->_objects.begin(); it != this->_objects.end(); ++it)
+    if ((*it)->getName() == name)
+      return (*it);
+  return NULL;
+}
+
+/**
+ * @brief checks if Object object exists in this ClassList.
+ * @param object the Object to check for
+ * @returns True if the object is found within the List, false otherwise
+ */
+template <class T>
+bool ObjectList<T>::exists(const T* const object) const
+{
+  return (std::find(_objects.begin(), _objects.end(), object) != _objects.end());
+}
+
+
+/**
+ * @brief retrieves a List of BaseObjects
+ * @param list the list to push the ObjectList into.
+ */
+template <class T>
+void ObjectList<T>::getBaseObjectList(ObjectListBase::base_list* list) const
+{
+  assert (list != NULL);
+  const_iterator it;
+  for (it = this->_objects.begin(); it != this->_objects.end(); ++it)
+    list->push_back(*it);
+}
+
+
+/**
+ * @brief registers an Object to the ObjectList.
+ * @param object The Object to register.
+ * @returns a pointer to the iterator inside of the list.
+ */
+template <class T>
+ObjectListBase::IteratorBase* ObjectList<T>::registerObject(T* object)
+{
+  this->_objects.push_back(object);
+  return new Iterator(--this->_objects.end());
+}
+
+/**
+ * @brief removes an Object from the ClassList.
+ * @param iterator the Position at which to remove the Object.
+ */
+template <class T>
+void ObjectList<T>::unregisterObject(IteratorBase* iterator)
+{
+  this->_objects.erase(static_cast<Iterator*>(iterator)->it());
+  //_objects.erase(std::find(_objects.begin(), _objects.end(), object));
+}
+
+template <class T>
+bool ObjectList<T>::checkIteratorInList(IteratorBase* iterator) const
+{
+  const_iterator it;
+  for (it = this->_objects.begin(); it != this->_objects.end(); ++it)
+    if (static_cast<Iterator*>(iterator)->it() == it)
+      return true;
+  printf("ObjectList:: checkIteratorInList:: ITERATOR NOT IN THE LIST '%s' (UN-SYNC SHOULD NOT HAPPEN!!)\n", this->name().c_str());
+  return false;
+}
+
+template <class T>
+bool ObjectList<T>::checkObjectInList(BaseObject* obj) const
+{
+  T* object = dynamic_cast<T*>(obj);
+  if (object != NULL)
+  {
+    printf("EXTREME BUG: Object does not exist anymore!! (or a bug in ObjectList)\n");
+    return false;;
+  }
+
+  const_iterator it;
+  for (it = this->_objects.begin(); it != this->_objects.end(); ++it)
+  {
+    if (*it == object)
+      return true;
+  }
+  printf("ObjectList:: checkObjectInList:: OBJECT NOT IN THE LIST '%s' (UN-SYNC SHOULD NOT HAPPEN!!)\n", this->name().c_str());
+  return false;
+}
+
+
+#endif /* _OBJECT_LIST_H */
Index: trunk/src/lib/network/converter.cc
===================================================================
--- trunk/src/lib/network/converter.cc	(revision 9682)
+++ trunk/src/lib/network/converter.cc	(revision 9869)
@@ -28,5 +28,5 @@
 SHELL_COMMAND_STATIC(debug, Converter, Converter::debug);
 
-
+ObjectListDefinition(Converter);
 /* using namespace std is default, this needs to be here */
 
Index: trunk/src/lib/network/converter.h
===================================================================
--- trunk/src/lib/network/converter.h	(revision 9682)
+++ trunk/src/lib/network/converter.h	(revision 9869)
@@ -24,4 +24,5 @@
 class Converter : public BaseObject
 {
+  ObjectListDeclaration(Converter);
   public:
     static byte* intToByteArray(int x);
Index: trunk/src/lib/network/data_stream.cc
===================================================================
--- trunk/src/lib/network/data_stream.cc	(revision 9682)
+++ trunk/src/lib/network/data_stream.cc	(revision 9869)
@@ -20,6 +20,5 @@
 /* using namespace std is default, this needs to be here */
 
-
-
+ObjectListDefinition(DataStream);
 
 /**
@@ -28,5 +27,4 @@
 DataStream::DataStream()
 {
-  this->setClassID(CL_DATA_STREAM, "DataStream");
   this->upBuffer = new byte[DATA_STREAM_BUFFER_SIZE];
   this->downBuffer = new byte[DATA_STREAM_BUFFER_SIZE];
@@ -38,5 +36,5 @@
 DataStream::DataStream(DataStream& inStream, DataStream& outStream)
 {
-    this->setClassID(CL_DATA_STREAM, "DataStream");
+  this->registerObject(this, DataStream::_objectList);
     this->downStream = &outStream;
     this->upStream = &inStream;
Index: trunk/src/lib/network/data_stream.h
===================================================================
--- trunk/src/lib/network/data_stream.h	(revision 9682)
+++ trunk/src/lib/network/data_stream.h	(revision 9869)
@@ -17,5 +17,6 @@
 class DataStream : public BaseObject
 {
-      public:
+  ObjectListDeclaration(DataStream);
+  public:
       DataStream();
       DataStream(DataStream& inStream, DataStream& outStream);
Index: trunk/src/lib/network/handshake.cc
===================================================================
--- trunk/src/lib/network/handshake.cc	(revision 9682)
+++ trunk/src/lib/network/handshake.cc	(revision 9869)
@@ -23,5 +23,5 @@
 
 
-
+ObjectListDefinition(Handshake);
 
 
@@ -30,5 +30,5 @@
 {
   /* set the class id for the base object */
-  this->setClassID(CL_HANDSHAKE, "Handshake");
+  this->registerObject(this, Handshake::_objectList);
 
 
Index: trunk/src/lib/network/handshake.h
===================================================================
--- trunk/src/lib/network/handshake.h	(revision 9682)
+++ trunk/src/lib/network/handshake.h	(revision 9869)
@@ -42,5 +42,5 @@
 class Handshake : public Synchronizeable
 {
-
+  ObjectListDeclaration(Handshake);
   public:
     Handshake( int nodeType, int clientId = 0, int networkGameManagerId = 0, int messageManagerId = 0 );
Index: trunk/src/lib/network/message_manager.cc
===================================================================
--- trunk/src/lib/network/message_manager.cc	(revision 9682)
+++ trunk/src/lib/network/message_manager.cc	(revision 9869)
@@ -28,5 +28,5 @@
 
 
-
+ObjectListDefinition(MessageManager);
 MessageManager* MessageManager::singletonRef = NULL;
 
@@ -37,5 +37,5 @@
 MessageManager::MessageManager ()
 {
-  this->setClassID( CL_MESSAGE_MANAGER, "MessageManager" );
+  this->registerObject(this, MessageManager::_objectList);
   newNumber = 1;
   setSynchronized( true );
Index: trunk/src/lib/network/message_manager.h
===================================================================
--- trunk/src/lib/network/message_manager.h	(revision 9682)
+++ trunk/src/lib/network/message_manager.h	(revision 9869)
@@ -96,5 +96,5 @@
 class MessageManager : public Synchronizeable {
 
-
+  ObjectListDeclaration(MessageManager);
  public:
    inline static MessageManager * getInstance(){ if (!singletonRef) singletonRef = new MessageManager();  return singletonRef; }
Index: trunk/src/lib/network/monitor/connection_monitor.cc
===================================================================
--- trunk/src/lib/network/monitor/connection_monitor.cc	(revision 9682)
+++ trunk/src/lib/network/monitor/connection_monitor.cc	(revision 9869)
@@ -23,5 +23,5 @@
 /* using namespace std is default, this needs to be here */
 
-
+ObjectListDefinition(ConnectionMonitor);
 /**
  * constructor
@@ -31,5 +31,5 @@
 {
   /* set the class id for the base object and add ist to class list*/
-  this->setClassID(CL_CONNECTION_MONITOR, "ConnectionMonitor");
+  this->registerObject(this, ConnectionMonitor::_objectList);
 
   this->userId = userId;
Index: trunk/src/lib/network/monitor/connection_monitor.h
===================================================================
--- trunk/src/lib/network/monitor/connection_monitor.h	(revision 9682)
+++ trunk/src/lib/network/monitor/connection_monitor.h	(revision 9869)
@@ -19,4 +19,5 @@
 class ConnectionMonitor : virtual public BaseObject
 {
+  ObjectListDeclaration(ConnectionMonitor);
   public:
     ConnectionMonitor( int userId );
Index: trunk/src/lib/network/monitor/network_monitor.cc
===================================================================
--- trunk/src/lib/network/monitor/network_monitor.cc	(revision 9682)
+++ trunk/src/lib/network/monitor/network_monitor.cc	(revision 9869)
@@ -37,4 +37,5 @@
 SHELL_COMMAND(debug, NetworkMonitor, debug);
 
+ObjectListDefinition(NetworkMonitor);
 
 
@@ -45,5 +46,5 @@
   : Synchronizeable()
 {
-  this->setClassID(CL_NETWORK_MONITOR, "NetworkMonitor");
+  this->registerObject(this, NetworkMonitor::_objectList);
 
   this->networkStream = networkStream;
Index: trunk/src/lib/network/monitor/network_monitor.h
===================================================================
--- trunk/src/lib/network/monitor/network_monitor.h	(revision 9682)
+++ trunk/src/lib/network/monitor/network_monitor.h	(revision 9869)
@@ -27,5 +27,5 @@
 class NetworkMonitor : public Synchronizeable
 {
-
+  ObjectListDeclaration(NetworkMonitor);
   public:
     NetworkMonitor(NetworkStream* networkStream);
Index: trunk/src/lib/network/monitor/network_stats_widget.cc
===================================================================
--- trunk/src/lib/network/monitor/network_stats_widget.cc	(revision 9682)
+++ trunk/src/lib/network/monitor/network_stats_widget.cc	(revision 9869)
@@ -20,9 +20,9 @@
 #include "peer_info.h"
 
+#include "loading/resource_manager.h"
+
 #include "multi_type.h"
 
 #include "shell_command.h"
-
-#include "loading/resource_manager.h"
 
 // this fcuk does not work!
@@ -30,5 +30,4 @@
 // ->setAlias("ProxyGui");
 
-
 HostWidget::HostWidget(const std::string& name, const IP& ip)
     : GLGuiBox(OrxGui::Horizontal)
@@ -57,5 +56,5 @@
 {
   if(_font == NULL)
-    _font = new Font(ResourceManager::getInstance()->getDataDir() + "/fonts/arial.ttf", 20);
+    _font = new Font(Resources::ResourceManager::getInstance()->mainGlobalPath().name() + "/fonts/arial.ttf", 20);
 
   //this->_name.setFont(*_font);
@@ -211,4 +210,6 @@
 //======================================================//
 
+
+ObjectListDefinition(NetworkStatsWidget);
 /**
  * @brief standard constructor
@@ -273,16 +274,13 @@
 NetworkStatsWidget* NetworkStatsWidget::_statsWidget = NULL;
 
-#include "class_list.h"
-
 void NetworkStatsWidget::toggleGUI()
 {
-  BaseObject* bo = NULL;
-  const std::list<BaseObject*>* ls = ClassList::getList(CL_NETWORK_MONITOR);
-  if (ls != NULL && !ls->empty())
-    bo = ls->front();
-
-  if (bo != NULL && NetworkStatsWidget::_statsWidget == NULL)
-  {
-    NetworkStatsWidget::_statsWidget = new NetworkStatsWidget(dynamic_cast<NetworkMonitor*> (bo));
+  NetworkMonitor* monitor;
+  if (!NetworkMonitor::objectList().empty())
+    monitor = NetworkMonitor::objectList().front();
+
+  if (monitor != NULL && NetworkStatsWidget::_statsWidget == NULL)
+  {
+    NetworkStatsWidget::_statsWidget = new NetworkStatsWidget(monitor);
     NetworkStatsWidget::_statsWidget->showAll();
   }
Index: trunk/src/lib/network/monitor/network_stats_widget.h
===================================================================
--- trunk/src/lib/network/monitor/network_stats_widget.h	(revision 9682)
+++ trunk/src/lib/network/monitor/network_stats_widget.h	(revision 9869)
@@ -81,4 +81,5 @@
 class NetworkStatsWidget : public OrxGui::GLGuiFixedpositionBox
 {
+  ObjectListDeclaration(NetworkStatsWidget);
   public:
     static void toggleGUI();
Index: trunk/src/lib/network/network_game_manager.cc
===================================================================
--- trunk/src/lib/network/network_game_manager.cc	(revision 9682)
+++ trunk/src/lib/network/network_game_manager.cc	(revision 9869)
@@ -23,5 +23,4 @@
 #include "util/loading/factory.h"
 #include "state.h"
-#include "class_list.h"
 #include "debug.h"
 
@@ -43,9 +42,9 @@
 #include "multiplayer_team_deathmatch.h"
 
-#include "preferences.h"
-
-
-
-
+#include "parser/preferences/preferences.h"
+
+
+
+ObjectListDefinition(NetworkGameManager);
 NetworkGameManager* NetworkGameManager::singletonRef = NULL;
 
@@ -59,5 +58,5 @@
 
   /* set the class id for the base object */
-  this->setClassID(CL_NETWORK_GAME_MANAGER, "NetworkGameManager");
+  this->registerObject(this, NetworkGameManager::_objectList);
 
   this->setSynchronized(true);
@@ -93,10 +92,10 @@
   assert( SharedNetworkData::getInstance()->isMasterServer());
   assert( State::getGameRules() );
-  assert( State::getGameRules()->isA( CL_NETWORK_GAME_RULES ) );
+  assert( State::getGameRules()->isA( NetworkGameRules::staticClassID()) );
 
   NetworkGameRules & rules = *(dynamic_cast<NetworkGameRules*>(State::getGameRules()));
 
   int          team = rules.getTeamForNewUser();
-  ClassID      playableClassId = rules.getPlayableClassId( userId, team );
+  ClassID   playableClassId = rules.getPlayableClassId( userId, team );
   std::string  playableModel = rules.getPlayableModelFileName( userId, team, playableClassId );
   std::string  playableTexture = rules.getPlayableModelFileName( userId, team, playableClassId );
@@ -106,5 +105,5 @@
 
   assert( bo != NULL );
-  assert( bo->isA( CL_PLAYABLE ) );
+  assert( bo->isA( Playable::staticClassID()) );
 
   Playable & playable = *(dynamic_cast<Playable*>(bo));
@@ -131,5 +130,5 @@
     stats->setNickName( Preferences::getInstance()->getString( "multiplayer", "nickname", "Server" ) );
 
-  if ( rules.isA( CL_MULTIPLAYER_TEAM_DEATHMATCH ) )
+  if ( rules.isA( MultiplayerTeamDeathmatch::staticClassID()) )
     dynamic_cast<MultiplayerTeamDeathmatch*>(&rules)->respawnPlayable( &playable, team, 0.0f );
 
@@ -187,11 +186,11 @@
   }
 
-  const std::list<BaseObject*> * list = ClassList::getList( CL_SYNCHRONIZEABLE );
-
-  for ( std::list<BaseObject*>::const_iterator it = list->begin(); it != list->end(); it++ )
-  {
-    if ( dynamic_cast<Synchronizeable*>(*it)->getUniqueID() == uniqueId )
+  for (ObjectList<Synchronizeable>::const_iterator it = Synchronizeable::objectList().begin();
+       it != Synchronizeable::objectList().end();
+      ++it)
+  {
+    if ( (*it)->getUniqueID() == uniqueId )
     {
-      if ( (*it)->isA(CL_PLAYABLE) )
+      if ( (*it)->isA(Playable::staticClassID()) )
       {
         getInstance()->playablesToDelete.push_back( dynamic_cast<Playable*>(*it) );
@@ -199,5 +198,5 @@
       }
 
-      delete dynamic_cast<Synchronizeable*>(*it);
+      delete (*it);
       return true;
     }
@@ -297,7 +296,5 @@
     if ( State::getPlayer()->getPlayable() != *it )
     {
-      const std::list<BaseObject*> * list = ClassList::getList( CL_PLAYABLE );
-
-      if ( list && std::find( list->begin(), list->end(), *it ) != list->end() )
+      if ( std::find( Playable::objectList().begin(), Playable::objectList().end(), *it ) != Playable::objectList().end() )
       {
         PRINTF(0)("Delete unused playable: %s owner: %d\n", (*it)->getClassCName(), (*it)->getOwner() );
@@ -324,5 +321,5 @@
 
   assert( State::getGameRules() );
-  assert( State::getGameRules()->isA( CL_NETWORK_GAME_RULES ) );
+  assert( State::getGameRules()->isA( NetworkGameRules::staticClassID()) );
 
   NetworkGameRules & rules = *(dynamic_cast<NetworkGameRules*>(State::getGameRules()));
Index: trunk/src/lib/network/network_game_manager.h
===================================================================
--- trunk/src/lib/network/network_game_manager.h	(revision 9682)
+++ trunk/src/lib/network/network_game_manager.h	(revision 9869)
@@ -33,9 +33,9 @@
 class NetworkGameManager: public Synchronizeable
 {
-
+  ObjectListDeclaration(NetworkGameManager);
   public:
     virtual ~NetworkGameManager();
 
-    static NetworkGameManager* NetworkGameManager::getInstance()
+    static NetworkGameManager* getInstance()
     { if (!NetworkGameManager::singletonRef) NetworkGameManager::singletonRef = new NetworkGameManager(); return NetworkGameManager::singletonRef; }
 
Index: trunk/src/lib/network/network_log.cc
===================================================================
--- trunk/src/lib/network/network_log.cc	(revision 9682)
+++ trunk/src/lib/network/network_log.cc	(revision 9869)
@@ -15,4 +15,5 @@
 
 #include "network_log.h"
+#include <cassert>
 
 /**
@@ -53,11 +54,11 @@
     return false;
   }
-  
+
   listensock = SDLNet_TCP_Open( &ip );
-  
+
   if( !listensock ) {
     PRINT(1)( "SDLNet_TCP_Open: %s\n", SDLNet_GetError() );
     return false;
-  } 
+  }
 
   return true;
@@ -71,9 +72,9 @@
   va_list ap;
   va_start( ap, format );
-  
-  assert( vsnprintf( buf, NETWORK_LOG_BUFLEN, format, ap ) < NETWORK_LOG_BUFLEN );
-  
-  va_end( ap );
- 
+
+  assert( vsnprintf( buf, NETWORK_LOG_BUFLEN, format, ap ) < NETWORK_LOG_BUFLEN );
+
+  va_end( ap );
+
   printfnet();
 }
@@ -85,5 +86,5 @@
 {
   TCPsocket newSock = SDLNet_TCP_Accept( listensock );
-  
+
   if ( newSock )
     sockets.push_back( newSock );
@@ -97,9 +98,9 @@
   va_list ap;
   va_start( ap, format );
-  
-  assert( vsnprintf( buf, NETWORK_LOG_BUFLEN, format, ap ) < NETWORK_LOG_BUFLEN );
-  
-  va_end( ap );
-  
+
+  assert( vsnprintf( buf, NETWORK_LOG_BUFLEN, format, ap ) < NETWORK_LOG_BUFLEN );
+
+  va_end( ap );
+
   PRINT(0)( buf );
   printfnet();
@@ -114,9 +115,9 @@
   va_list ap;
   va_start( ap, format );
-  
-  assert( vsnprintf( buf, NETWORK_LOG_BUFLEN, format, ap ) < NETWORK_LOG_BUFLEN );
-  
-  va_end( ap );
-  
+
+  assert( vsnprintf( buf, NETWORK_LOG_BUFLEN, format, ap ) < NETWORK_LOG_BUFLEN );
+
+  va_end( ap );
+
   PRINT(1)( buf );
   printfnet();
@@ -131,9 +132,9 @@
   va_list ap;
   va_start( ap, format );
-  
-  assert( vsnprintf( buf, NETWORK_LOG_BUFLEN, format, ap ) < NETWORK_LOG_BUFLEN );
-  
-  va_end( ap );
-  
+
+  assert( vsnprintf( buf, NETWORK_LOG_BUFLEN, format, ap ) < NETWORK_LOG_BUFLEN );
+
+  va_end( ap );
+
   PRINT(2)( buf );
   printfnet();
@@ -148,9 +149,9 @@
   va_list ap;
   va_start( ap, format );
-  
-  assert( vsnprintf( buf, NETWORK_LOG_BUFLEN, format, ap ) < NETWORK_LOG_BUFLEN );
-  
-  va_end( ap );
-  
+
+  assert( vsnprintf( buf, NETWORK_LOG_BUFLEN, format, ap ) < NETWORK_LOG_BUFLEN );
+
+  va_end( ap );
+
   PRINT(3)( buf );
   printfnet();
@@ -165,9 +166,9 @@
   va_list ap;
   va_start( ap, format );
-  
-  assert( vsnprintf( buf, NETWORK_LOG_BUFLEN, format, ap ) < NETWORK_LOG_BUFLEN );
-  
-  va_end( ap );
-  
+
+  assert( vsnprintf( buf, NETWORK_LOG_BUFLEN, format, ap ) < NETWORK_LOG_BUFLEN );
+
+  va_end( ap );
+
   PRINT(4)( buf );
   printfnet();
@@ -182,9 +183,9 @@
   va_list ap;
   va_start( ap, format );
-  
-  assert( vsnprintf( buf, NETWORK_LOG_BUFLEN, format, ap ) < NETWORK_LOG_BUFLEN );
-  
-  va_end( ap );
-  
+
+  assert( vsnprintf( buf, NETWORK_LOG_BUFLEN, format, ap ) < NETWORK_LOG_BUFLEN );
+
+  va_end( ap );
+
   PRINT(5)( buf );
   printfnet();
@@ -200,5 +201,5 @@
   if ( !listensock )
     return;
-  
+
   acceptNewConnections();
 
@@ -213,5 +214,5 @@
       continue;
     }
-    
+
     it++;
   }
